
//------------------------------------------------------------------------
//  Conqeror (), . http://ironfelix.ru
// :         .
//  PB0, PB1, PB2, PB3,  PB4, PB5, PB6, PB7 .
//        . 
//    WinAVR v3.4.5,    20060125.
//------------------------------------------------------------------------


#include <avr/io.h>
//#include <stdio.h>
#include <avr/interrupt.h>
//#include <avr/signal.h>
#include <compat/deprecated.h>

unsigned char led;

//   
SIGNAL(SIG_OVERFLOW0)        //     tcnt0 
{
    outp(PORTD, ~led);       //    : LED  
    led <<= 1;               // move to next LED 
    if (!led)                // : start with Port D4 again 
        led = 1;
    outp(TCNT0, 0);          //       
}

int main(void)
{
uint8_t   keys;

  DDRB  = 0xf0;  //  PB4, 5, 6, 7  , PB0, 1, 2, 3  
  PORTB = 0x0f;  //     
                  //      

    outp(DDRD, 0xff);         //      PD   

    outp(TIMSK, (1<<TOIE0)); //   TCNT0 
    outp(TCNT0, 0);        //  TCNT0 
    outp(TCCR0, 5);        //     1024 

    led = 1;                 //   LED 
    sei();                   //   

  for (;;) {     // "" 
	
    keys = ~PINB;                  //     B

    if (keys & 1) cbi(PORTB, PB4); //     PD0  PB4
    else sbi(PORTB, PB4);          //   -  PB4

    if (keys & 2) cbi(PORTB, PB5); //     PD1  PB5
    else sbi(PORTB, PB5);          //   -  PB5

    if (keys & 4) cbi(PORTB, PB6); //     PD2  PB6
    else sbi(PORTB, PB6);          //   -  PB6

    if (keys & 8) cbi(PORTB, PB7); //     PD3  PB7
    else sbi(PORTB, PB7);          //   -  PB7
         }
  
}
